# -*- coding: utf-8 -*-
"""
Created on Mon Apr 12 13:10:10 2021

@author: viviana
"""
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.covariance import EllipticEnvelope
from sklearn.ensemble import IsolationForest
from sklearn.neighbors import LocalOutlierFactor
from sklearn import svm

#registro de datos de vibraciones en RMS
Datos = pd.read_csv('RMSvibraciones1.txt')

#registro de tiempo en minutos
t= pd.read_csv('time1.txt')

plt.figure()
plt.plot(t/60,Datos)
plt.xlabel('tiempo (horas)', fontsize=14)
plt.ylabel('RMS vibraciones', fontsize=14)
plt.legend(['R1','R2','R3','R4'])
plt.title('Falla en pista interna R3 y falla en bolas R4')

Datos_train=Datos.to_numpy()[0:999,:] #caso 1 999, caso 2 449, caso 3 2999
Datos_test=Datos.to_numpy()

outlier_frac=0.001 #fracción de valores anomalos, valor por defecto es 0.1
Modelo=EllipticEnvelope(contamination=outlier_frac) 
title='Elliptic Envelope'
#Modelo=IsolationForest(n_estimators=100, max_samples='auto', contamination=outlier_frac) 
#title='Isolation Forest'
#Modelo=LocalOutlierFactor(n_neighbors=20, contamination=outlier_frac, novelty=True) 
#title='Local Outlier Factor'
# Modelo = svm.OneClassSVM(nu=0.01, kernel="rbf", gamma='auto') 
# title='SVM'

Modelo.fit(Datos_train)
Yp=Modelo.predict(Datos_test)

Xp0=Datos_test[np.where(Yp == 1)[0],:]      
Xp1=Datos_test[np.where(Yp == -1)[0],:]

t0=t.to_numpy()[np.where(Yp == 1)]    
t1=t.to_numpy()[np.where(Yp == -1)]

plt.figure()
plt.plot(t0/60,Xp0,'k')
plt.plot(t1/60,Xp1,'rx')
plt.title(title)
plt.xlabel('tiempo (horas)', fontsize=14)
plt.ylabel('RMS vibraciones', fontsize=14)
plt.show()